indexing
	description: "Program points at function exits, but containing all the variables except Result"
	author: "Flaviu Roman"
	date: "$Date$"
	revision: "$Revision$"

class
	CI_SURROGATE_FUNCTION_EXIT

inherit
	CI_ROUTINE_EXIT
		redefine
			kind,
			add_variables,
			state_printing_function_name,
			annotate,
			instrument
		end

create
	make

feature -- Access
	kind (a_visitor: CI_PROGRAM_POINT_KIND_FORMAT): STRING is
			-- Program point kind name
		do
			Result := a_visitor.surrogate_function_exit_kind
		end

feature -- Assertions
	instrument is
			-- Instrument program point by making `checked_assertions' call `state_printing_function'
		do
		end

	annotate is
			-- Do nothing because the point is surrogate
		do
		end

feature {NONE} -- Assertions
	state_printing_function_name: ET_FEATURE_NAME is
			-- Name of `state_printing_function' for this program point
		do
			create {ET_IDENTIFIER} Result.make (surrounding_class.lower_name + "_" +
				identifier_name (surrounding_routine.name).lower_name + "_surrogate_post_")
		end

feature {NONE} -- Implementation
	add_variables is
			-- Find variables in scope and store them into `variables'
			-- Remove "Result" from precursor variables
		local
			res: CI_RESULT
		do
			Precursor
			create res.make (surrounding_function, surrounding_class, universe)
			variables.prune (res)
		end
end
