indexing
	description: "Suppression of all kinds of properties by class invariants of involved variables (renames targets of quesries into Current)"
	author: ""
	date: "$Date$"
	revision: "$Revision$"

class
	CI_SUPPLIER_INVARIANT_SUPPRESSION

inherit
	CI_SUPPRESSION
		rename
			make as unsafe_make
		redefine
			suppressor,
			renamed_query
		end

create
	make

feature -- Initialization
	make (a_suppressor: CI_STABLE_TIME) is
			-- Create a suppression by `a_suppressor' (can be only a class inavriant point)
		require
			a_suppressor_exists: a_suppressor /= Void
		do
			suppressor := a_suppressor
			create helper.make (suppressor)
		ensure
			suppressor_set: suppressor = a_suppressor
		end

feature -- Access
	suppressor: CI_STABLE_TIME
			-- Suppressor program point	

feature -- Variable renaming
	renamed_current (a_variable: CI_CURRENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_argument (a_variable: CI_FORMAL_ARGUMENT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_local (a_variable: CI_LOCAL_ENTITY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_result (a_variable: CI_RESULT): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		do
		end

	renamed_query (a_variable: CI_QUERY): CI_VARIABLE is
			-- Name of `a_variable' in the `suppressor'
		local
			target: CI_VARIABLE
		do
			target := a_variable.target.renamed (helper)
			if target /= Void then
				create {CI_QUERY} Result.make (a_variable.ast_node, target)
			end
		end

feature {NONE} -- Implementation
	helper: CI_SUPPLIER_INVARIANT_HELPER
end
