indexing
	description: "Eiffel token and symbol constants.%
		% Adds some extra class and feature names"
	author: "Nadia Polikarpova"
	date: "$Date$"
	revision: "$Revision$"

class
	CI_TOKEN_CONSTANTS

inherit
	ET_TOKEN_CONSTANTS

feature -- Class names
	exceptions_class_name: ET_CLASS_NAME is
			-- `EXCEPTIONS' class name
		once
			create {ET_IDENTIFIER} Result.make ("EXCEPTIONS")
		end

	internal_class_name: ET_CLASS_NAME is
			-- `INTERNAL' class name
		once
			create {ET_IDENTIFIER} Result.make ("INTERNAL")
		end

	plain_text_file_class_name: ET_CLASS_NAME is
			-- `PLAIN_TEXT_FILE' class name
		once
			create {ET_IDENTIFIER} Result.make ("PLAIN_TEXT_FILE")
		end

feature -- Feature names
	io_feature_name: ET_IDENTIFIER is
			-- Name of `print' feature from `ANY'
		once
			create Result.make ("io")
		end

	print_feature_name: ET_IDENTIFIER is
			-- Name of `print' feature from `ANY'
		once
			create Result.make ("print")
		end

	to_integer_feature_name: ET_IDENTIFIER is
			-- Name of `to_integer' feature
		once
			create Result.make ("to_integer")
		end

	class_name_feature_name: ET_IDENTIFIER is
			-- Name of `class_name' feature from `INTERNAL'
		once
			create Result.make ("class_name")
		end

	type_name_feature_name: ET_IDENTIFIER is
			-- Name of `type_name' feature from `INTERNAL'
		once
			create Result.make ("type_name")
		end

	field_feature_name: ET_IDENTIFIER is
			-- Name of `field' feature from `INTERNAL'
		once
			create Result.make ("field")
		end

	field_count_feature_name: ET_IDENTIFIER is
			-- Name of `field_count' feature from `INTERNAL'
		once
			create Result.make ("field_count")
		end

	field_name_feature_name: ET_IDENTIFIER is
			-- Name of `field_name' feature from `INTERNAL'
		once
			create Result.make ("field_name")
		end

	field_type_feature_name: ET_IDENTIFIER is
			-- Name of `field_type' feature from `INTERNAL'
		once
			create Result.make ("field_type")
		end

	boolean_type_feature_name: ET_IDENTIFIER is
			-- Name of `boolean_type' feature from `INTERNAL'
		once
			create Result.make ("boolean_type")
		end

	integer_8_type_feature_name: ET_IDENTIFIER is
			-- Name of `ineteger_8_type' feature from `INTERNAL'
		once
			create Result.make ("integer_8_type")
		end

	integer_16_type_feature_name: ET_IDENTIFIER is
			-- Name of `ineteger_16_type' feature from `INTERNAL'
		once
			create Result.make ("integer_16_type")
		end

	integer_32_type_feature_name: ET_IDENTIFIER is
			-- Name of `ineteger_32_type' feature from `INTERNAL'
		once
			create Result.make ("integer_32_type")
		end

	integer_64_type_feature_name: ET_IDENTIFIER is
			-- Name of `ineteger_64_type' feature from `INTERNAL'
		once
			create Result.make ("integer_64_type")
		end

	natural_8_type_feature_name: ET_IDENTIFIER is
			-- Name of `natural_8_type' feature from `INTERNAL'
		once
			create Result.make ("natural_8_type")
		end

	natural_16_type_feature_name: ET_IDENTIFIER is
			-- Name of `natural_16_type' feature from `INTERNAL'
		once
			create Result.make ("natural_16_type")
		end

	natural_32_type_feature_name: ET_IDENTIFIER is
			-- Name of `natural_32_type' feature from `INTERNAL'
		once
			create Result.make ("natural_32_type")
		end

	natural_64_type_feature_name: ET_IDENTIFIER is
			-- Name of `natural_64_type' feature from `INTERNAL'
		once
			create Result.make ("natural_64_type")
		end

	character_8_type_feature_name: ET_IDENTIFIER is
			-- Name of `character_8_type' feature from `INTERNAL'
		once
			create Result.make ("character_8_type")
		end

	character_32_type_feature_name: ET_IDENTIFIER is
			-- Name of `character_8_type' feature from `INTERNAL'
		once
			create Result.make ("character_32_type")
		end

	real_32_type_feature_name: ET_IDENTIFIER is
			-- Name of `real_32_type' feature from `INTERNAL'
		once
			create Result.make ("real_32_type")
		end

	real_64_type_feature_name: ET_IDENTIFIER is
			-- Name of `real_64_type' feature from `INTERNAL'
		once
			create Result.make ("real_64_type")
		end

	pointer_type_feature_name: ET_IDENTIFIER is
			-- Name of `pointer_type' feature from `INTERNAL'
		once
			create Result.make ("pointer_type")
		end

	string_feature_name: ET_IDENTIFIER is
			-- Name of `string' feature from `STRING'
		once
			create Result.make ("string")
		end

	is_empty_feature_name: ET_IDENTIFIER is
			-- Name of `is_empty' feature
		once
			create Result.make ("is_empty")
		end

	has_substring_feature_name: ET_IDENTIFIER is
			-- Name of `has_substring' feature from `STRING'
		once
			create Result.make ("has_substring")
		end

	replace_substring_all_feature_name: ET_IDENTIFIER is
			-- Name of `replace_substring_all' feature from `STRING'
		once
			create Result.make ("replace_substring_all")
		end

	put_string_feature_name: ET_IDENTIFIER is
			-- Name of `put_string' feature from `IO_MEDIUM'
		once
			create Result.make ("put_string")
		end

	new_line_feature_name: ET_IDENTIFIER is
			-- Name of `new_line' feature from `IO_MEDIUM'
		once
			create Result.make ("new_line")
		end

	make_open_write_feature_name: ET_FEATURE_NAME is
			-- Name of `make_open_write' feature from `FILE'
		once
			create {ET_IDENTIFIER} Result.make ("make_open_write")
		end

	make_open_append_feature_name: ET_FEATURE_NAME is
			-- Name of `make_open_append' feature from `FILE'
		once
			create {ET_IDENTIFIER} Result.make ("make_open_append")
		end

	flush_feature_name: ET_FEATURE_NAME is
			-- Name of `flush' feature from `FILE'
		once
			create {ET_IDENTIFIER} Result.make ("flush")
		end

	copy_to_feature_name: ET_FEATURE_NAME is
			-- Name of `copy_to' feature from `FILE'
		once
			create {ET_IDENTIFIER} Result.make ("copy_to")
		end

	die_feature_name: ET_FEATURE_NAME is
			-- Name of `die' feature from `EXCEPTIONS'
		once
			create {ET_IDENTIFIER} Result.make ("die")
		end

	is_hashable_feature_name: ET_FEATURE_NAME is
			-- Name of `is_hashable' feature from `HASHABLE'
		once
			create {ET_IDENTIFIER} Result.make ("is_hashable")
		end

feature -- Keywords
	and_then_operator: ET_INFIX_AND_THEN_OPERATOR is
			-- Infix `and then'
		once
			create Result.make
		end

	or_else_operator: ET_INFIX_OR_ELSE_OPERATOR is
			-- Infix `or else'
		once
			create Result.make
		end

	false_keyword: ET_FALSE_CONSTANT is
			-- "False" keyword
		once
			create Result.make
		end

feature -- Symbols
	comment_symbol_name: STRING is "--"
			-- Comment symbol

	double_quote: ET_SPECIAL_MANIFEST_STRING is
			-- Manifest string that denotes double quote
		once
			create Result.make ("%%%"", "%"")
		end

	underscore_symbol_character: CHARACTER is '_'
			-- Underscore

	dot_symbol_character: CHARACTER is '.'
			-- Dot

feature -- Breaks
	space: ET_BREAK is
			-- A space break
		once
			create Result.make (" ");
		end

	tab: ET_BREAK is
			-- A tab break
		once
			create Result.make ("%T")
		end

	new_line: ET_BREAK is
			-- A new line break
		once
			create Result.make ("%N")
		end

	inapplicable_name: STRING is "Inapplicable"
			-- Standard feature clause header comment "Inapplicable"

feature -- Status report
	is_identifier_symbol (c: CHARACTER): BOOLEAN is
			-- Can `c' appear in Eiffel identifier?
		do
			Result := c.is_alpha_numeric or c = underscore_symbol_character
		end

invariant
	exceptions_class_name_exists: exceptions_class_name /= Void
	internal_class_name_exists: internal_class_name /= Void
	plain_text_file_class_name_exists: plain_text_file_class_name /= Void
	print_feature_name_exists: print_feature_name /= Void
	to_integer_feature_name_exists: to_integer_feature_name /= Void
	class_name_feature_name_exists: class_name_feature_name /= Void
	type_name_feature_name_exists: type_name_feature_name /= Void
	field_feature_name_exists: field_feature_name /= Void
	field_count_feature_name_exists: field_count_feature_name /= Void
	fiels_name_feature_name_exists: field_name_feature_name /= Void
	has_substring_feature_name_exists: has_substring_feature_name /= Void
	put_string_feature_name_exists: put_string_feature_name /= Void
	new_line_feature_name_exists: new_line_feature_name /= Void
	make_open_write_feature_name_exists: make_open_write_feature_name /= Void
	make_open_append_feature_name_exists: make_open_append_feature_name /= Void
	flush_feature_name_exists: flush_feature_name /= Void
	die_feature_name_exists: die_feature_name /= Void
	and_then_exists: and_then_operator /= Void
	or_else_exists: or_else_operator /= Void
	false_keyword_exists: false_keyword /= Void
	comment_symbol_name_exists: comment_symbol_name /= Void
	space_exists: space /= Void
	tab_exists: tab /= Void
	new_line_exists: new_line /= Void
end
