indexing
	description: "Reference type kinds"
	author: "Nadia Polikarpova"
	date: "$Date$"
	revision: "$Revision$"

class
	CI_REFERENCE

inherit
	CI_VARIABLE_TYPE_KIND
		redefine
			uses_address,
			is_reference
		end

	CI_RUNTIME_OUTPUT_METACLIENT
		export {NONE}
			all
		end

create
	make

feature -- Access
	identity (a_variable: CI_VARIABLE): ET_EXPRESSION is
			-- Expression with printable result that identifies value of reference variable `a_variable'
		do
			create {ET_CALL_EXPRESSION} Result.make (parenthesized (a_variable.address_expression),
				tokens.to_integer_32_feature_name, Void)
		end

	uniform_identity (an_expression: ET_IDENTIFIER): ET_EXPRESSION is
			-- Identity expression that has the same type (`INTEGER') independently of `base_type'
		do
			create {ET_CALL_EXPRESSION} Result.make (parenthesized (create {ET_FEATURE_ADDRESS}.make (an_expression)),
				tokens.to_integer_32_feature_name, Void)
		end

	uniform_identity_argument_type: ET_TYPE is
			-- Reference type, which is a valid "argument" type for `uniform_identity'
		once
			Result := universe.any_type
		end

	representation_type (a_class_name: ET_CLASS_NAME): STRING is
			-- Name of Daikon representation type for reference type based on class called `a_class_name'
		once
			Result := hashcode_type
		end

	void_identity: ET_EXPRESSION is
			-- Identity of "Void" value
			-- TODO: needed for strings, as they are printable
		once
			create {ET_REGULAR_INTEGER_CONSTANT} Result.make ("0")
		end

feature -- Status report
	uses_address: BOOLEAN is
			-- Is variable's `address_expression' used in its `identity'?
		once
			Result := True
		end

	is_reference: BOOLEAN is
			-- Is type reference?
		once
			Result := True
		end
end
